// bsmtp64.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "bsmtp64.h"

#import "basp21pro.tlb" no_namespace


char* BSTR2A(VARIANT& v);
VARIANT A2VArray(char* ptr, int splitchar);


int BFileAttr(const char* name);



static VARIANT Str2Variant(const char* str)
{
	VARIANT v;
	VariantInit(&v);
	V_VT(&v) = VT_BSTR;
	V_BSTR(&v) = A2BSTR(str);
	return v;
}



DLL_EXPORT BSTR APIENTRY SendMail(BSTR* Server, BSTR* To, BSTR* From, BSTR* Subject, BSTR* Body, BSTR* File)
{

	char msg[1024];
	BSTR bstr;

	LPCSTR szServer = (LPCSTR)*Server;
	LPCSTR szTo = (LPCSTR)*To;
	LPCSTR szFrom = (LPCSTR)*From;
	LPCSTR szSubject = (LPCSTR)*Subject;
	LPCSTR szBody = (LPCSTR)*Body;
	LPCSTR szFile = (LPCSTR)*File;
	char temp[2] = "";
	if (!szServer)
		szServer = temp;
	if (!szTo)
		szTo = temp;
	if (!szFrom)
		szFrom = temp;
	if (!szSubject)
		szSubject = temp;
	if (!szBody)
		szBody = temp;
	if (!szFile)
		szFile = temp;

	msg[0] = 0;

	CoInitialize(NULL);

	try {
		Ibasp21pPtr pIBasp21(__uuidof(basp21p));

		pIBasp21->PutEnv("vba");
		if (BFileAttr(szServer) == 0) {
			pIBasp21->PutMailQueue(szServer);
		}
		else
			pIBasp21->PutServer(szServer);
		pIBasp21->PutMailFrom(szFrom);
		long rc = pIBasp21->SendMail(szTo, szSubject, szBody, szFile);

		if (rc < 0) { // error ?
			lstrcpy(msg, pIBasp21->GetLastMsg());
		}

		pIBasp21 = NULL;

	}
	catch (...) {
		lstrcpy(msg, "BASP21 Pro Object not found");

	}

	CoUninitialize();


	bstr = A2BSTR(msg);
	return bstr;

}



DLL_EXPORT VARIANT APIENTRY RcvMail(BSTR* Server, BSTR* Username, BSTR* Pass,
	BSTR* Command, BSTR* Dirname)
{

	LPCSTR szServer = (LPCSTR)*Server;
	LPCSTR szUser = (LPCSTR)*Username;
	LPCSTR szPass = (LPCSTR)*Pass;
	LPCSTR szCommand = (LPCSTR)*Command;
	LPCSTR szDirname = (LPCSTR)*Dirname;
	char temp[2] = "";
	if (!szServer)
		szServer = temp;
	if (!szUser)
		szUser = temp;
	if (!szPass)
		szPass = temp;
	if (!szCommand)
		szCommand = temp;
	if (!szDirname)
		szDirname = temp;

	VARIANT vret, v2;
	VariantInit(&vret);

	CoInitialize(NULL);

	try {
		Ibasp21pPtr pIBasp21(__uuidof(basp21p));

		pIBasp21->PutEnv("vba");
		pIBasp21->PutPopServer(szServer);

		vret = pIBasp21->RcvMail(szUser, szPass, szCommand, szDirname);

		if (pIBasp21->IsError) { // error ?
			v2 = Str2Variant(pIBasp21->GetLastMsg());
			pIBasp21 = NULL;
			CoUninitialize();
			return v2;
		}

		VARTYPE vt = V_VT(&vret);
		if (vt == (VT_VARIANT | VT_BYREF)) {
			VARIANT v = *vret.pvarVal;
			vt = V_VT(&v);
		}
		if (vt & VT_ARRAY) {  // VARIANT array ?
			v2 = Str2Variant("use [vba] entry\r\nmailoption2=array2str=1");
		}
		else {
			v2 = A2VArray(BSTR2A(vret), 1);
		}
		pIBasp21 = NULL;

	}
	catch (...) {
		v2 = Str2Variant("BASP21 Pro Object not found");
	}

	CoUninitialize();

	return v2;


}



DLL_EXPORT VARIANT APIENTRY ReadMail(BSTR* Filename, BSTR* Para, BSTR* Dirname)
{
	LPCSTR szFilename = (LPCSTR)*Filename;
	LPCSTR szPara = (LPCSTR)*Para;
	LPCSTR szDirname = (LPCSTR)*Dirname;
	char temp[2] = "";
	if (!szFilename)
		szFilename = temp;
	if (!szPara)
		szPara = temp;
	if (!szDirname)
		szDirname = temp;

	VARIANT vret, v2;
	VariantInit(&vret);

	CoInitialize(NULL);

	try {
		Ibasp21pPtr pIBasp21(__uuidof(basp21p));

		pIBasp21->PutEnv("vba");
		vret = pIBasp21->ReadMail(szFilename, szPara, szDirname);

		if (pIBasp21->IsError) { // error ?
			v2 = Str2Variant(pIBasp21->GetLastMsg());
			pIBasp21 = NULL;
			CoUninitialize();
			return v2;
		}

		VARTYPE vt = V_VT(&vret);
		if (vt == (VT_VARIANT | VT_BYREF)) {
			VARIANT v = *vret.pvarVal;
			vt = V_VT(&v);
		}
		if (vt & VT_ARRAY) {  // VARIANT array ?
			v2 = Str2Variant("use [vba] entry\r\nmailoption2=array2str=1");
		}
		else {
			v2 = A2VArray(BSTR2A(vret), 1);
		}
		pIBasp21 = NULL;

	}
	catch (...) {
		v2 = Str2Variant("BASP21 Pro Object not found");
	}

	CoUninitialize();

	return v2;

}


DLL_EXPORT int APIENTRY FlushMail(BSTR* svr, BSTR* dir, BSTR* logfile)
{
	LPCSTR szServer = (LPCSTR)*svr;
	LPCSTR szDirname = (LPCSTR)*dir;
	LPCSTR szLogfile = (LPCSTR)*logfile;
	char temp[2] = "";
	if (!svr)
		szServer = temp;
	if (!szDirname)
		szDirname = temp;
	if (!szLogfile)
		szLogfile = temp;

	int rc = 0;
	CoInitialize(NULL);

	try {
		Ibasp21pPtr pIBasp21(__uuidof(basp21p));

		pIBasp21->PutEnv("vba");
		char envstr[2048];
		lstrcpy(envstr, "+logfile=");
		lstrcat(envstr, szLogfile);
		pIBasp21->PutEnv(envstr);
		int rc = pIBasp21->FlushMail(szServer, szDirname);

		pIBasp21 = NULL;

	}
	catch (...) {
		rc = -999;
	}

	CoUninitialize();

	return rc;

}



// ؂蕶ŕAVARIANTzŕԂ 
VARIANT A2VArray(char* ptr, int splitchar)
{
	VARIANT pVal;
	VariantInit(&pVal);
	HRESULT hr;
	SAFEARRAYBOUND sabound[1];
	SAFEARRAY* psa = NULL;

	int i = 0;
	int len = lstrlen(ptr);
	int ctr = 0;
	for (i = 0; i < len; i++) {
		if (ptr[i] == splitchar)
			ctr++;
	}
	char data[8192];

	V_VT(&pVal) = VT_ARRAY | VT_VARIANT;
	sabound[0].cElements = ctr + 1;
	sabound[0].lLbound = 0;
	psa = SafeArrayCreate(VT_VARIANT, 1, sabound);
	if (psa == NULL)
		return pVal;
	VARIANT* pvData;
	hr = SafeArrayAccessData(psa, (LPVOID*)&pvData);
	if (FAILED(hr))
		return pVal;

	int j = 0;
	int k = 0;
	VARIANT vtemp;
	VariantInit(&vtemp);
	V_VT(&vtemp) = VT_BSTR;
	int max = sizeof(data) - 2;
	for (i = 0; i < len; i++) {
		if (ptr[i] != splitchar) {
			if (k >= max)
				break;
			data[k++] = ptr[i];
			continue;
		}
		data[k] = 0;
		V_BSTR(&vtemp) = A2BSTR(data);
		pvData[j++] = vtemp;
		k = 0;
	}
	data[k] = 0;
	V_BSTR(&vtemp) = A2BSTR(data);
	pvData[j++] = vtemp;

	SafeArrayUnaccessData(psa);

	V_ARRAY(&pVal) = psa;
	return pVal;
}



char* BSTR2A(VARIANT& v)
{
	BSTR bstr = v.bstrVal;
	int len = SysStringByteLen(bstr);
	char *tp = new char[len + 4];
	if (tp == NULL) {
		return NULL;
	}
	int nCLen = WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)bstr, -1, tp,
		len + 1, NULL, NULL);
	tp[nCLen] = 0;
	return tp;
}



#pragma warning( disable : 4312)
// ߂lF|P@G[
//			0 fBNg
//			1 t@C
int BFileAttr(const char* name)
{
	DWORD rc = GetFileAttributes(name);
	if ((HANDLE)rc == (HANDLE)INVALID_HANDLE_VALUE)
		return rc;
	if (rc & FILE_ATTRIBUTE_DIRECTORY) // dir ?
		return 0;
	return 1;
}
